import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { MpField, MpFieldParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询小程序配置
 */
export async function pageMpField(params: MpFieldParam) {
  const res = await request.get<ApiResult<PageResult<MpField>>>(
    MODULES_API_URL + '/cms/mp-field/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询小程序配置列表
 */
export async function listMpField(params?: MpFieldParam) {
  const res = await request.get<ApiResult<MpField[]>>(
    MODULES_API_URL + '/cms/mp-field',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加小程序配置
 */
export async function addMpField(data: MpField) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/mp-field',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改小程序配置
 */
export async function updateMpField(data: MpField) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/mp-field',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除小程序配置
 */
export async function removeMpField(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/mp-field/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除小程序配置
 */
export async function removeBatchMpField(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/mp-field/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询小程序配置
 */
export async function getMpField(id: number) {
  const res = await request.get<ApiResult<MpField>>(
    MODULES_API_URL + '/cms/mp-field/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 清除缓存
 */
export async function removeMpInfoCache(key?: string) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/mp-field/clearMpInfo/' + key
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 恢复项目参数
 */
export async function undeleteMpField(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/mp-field/undelete/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
